//+------------------------------------------------------------------+
//|                                                  testClass01.mq4 |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property version   "1.00"
#property strict
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+

#include <Object.mqh>
class TestCL {
private:
         int m_id;
         double m_a[];
public:
         TestCL(const int id, const int sz); // constructor  
        ~TestCL() {};                        //  destructor  
};
TestCL::TestCL(const int id, const int sz) {
   m_id = id;
   ArrayResize(m_a,sz);
};

class TestDerv1 : public TestCL {
private:
         int      m_id;
         double   m_a[];
         double   m_coeff1,m_coeff2;
         int      m_int0;
         string   m_name;
public:
                  TestDerv1(const int id, const int sz) : TestCL(id,sz) {};   // constructor  
                 ~TestDerv1(){};                                              //  destructor
      TestDerv1*  setParas1( const int id, const int sz,
                             const string name, const double c1, const double c2, const int i0);
         int      setParas2( const string name, const double c1, const double c2, const int i0);
};

int TestDerv1::setParas2( const string name, const double c1, const double c2, const int i0) {
      m_coeff1 = c1;
      m_coeff2 = c2;
      m_int0 = i0;
      m_name = name;
      if (ArraySize(m_a)>i0) ArrayResize(m_a,i0);
      return(i0);                          
}
TestDerv1* TestDerv1::setParas1( const int id, const int sz, const string name, const double c1, const double c2, const int i0) {
      TestDerv1* ret;
      ret = new TestDerv1(id,fmax(sz,i0));
      m_coeff1 = c1;
      m_coeff2 = c2;
      m_int0 = i0;
      m_name = name;
      return(ret);                          
}

// Script
void OnStart() {
   TestCL*  cl1 = TestDerv1::setParas1( 1,12,  "Test 1", 3.1416, 2.718281828459, 99);
   TestCL*  cl2 = new TestDerv1(2,12);
   cl2.setParas2( "Test 2", 3.1416, 2.718281828459, 99 );
}
